import { Meta, Story, Canvas, Description } from '@storybook/addon-docs/blocks';
import readme from './readme.md';
import { NavigationSidebarPosition } from "./navigation-sidebar-position.enum";
import { NavigationSidebarVariation } from "./navigation-sidebar-variation.enum";
import { NavigationSidebarMobileVariation } from "./navigation-sidebar-mobile-variation.enum";
import { NavigationSidebarHeadingLevel } from "./navigation-sidebar-heading-level.enum";
import { NavigationSidebarCloseButtonPosition } from "./navigation-sidebar-close-button-position.enum";
import { NavigationVerticalMenuVariation } from "../navigation-vertical-menu/navigation-vertical-menu-variation.enum";

<Meta
  title="Navigation/digi-navigation-sidebar"
  parameters={{
    actions: {
      handles: [
        'afOnClose',
        'afOnEsc',
        'afOnToggle',
        'afOnBackdropClick'
      ]
    }
  }}
/>

<!-- Description pulled from auto generated Stencil docs -->

<Description markdown={readme} />

## Standard

This is a default navigation sidebar.

<Canvas>
  <Story name="Standard">
    /* html */
    {`
      <style>
        header {
          position: relative;
          z-index: 2;
          background: var(--digi--ui--color--background);
          border-bottom: solid var(--digi--ui--color--border) var(--digi--ui--border--width);
        }
        .header-inner {
          display: flex;
          justify-content: space-between;
          align-items: center;
        }
        @media screen and (min-width: 768px) {
          digi-navigation-sidebar .digi-navigation-sidebar__wrapper--static {
            --digi-navigation-sidebar--wrapper--z-index: 1999;
          }
        }
      </style>
      <script>
        var afActive = true;
        function closeSidebar() {
          afActive = false;
          document.querySelector('digi-navigation-sidebar').setAttribute('af-active', afActive);
        }
        function setActiveMenuItem(target=null) {
          const menuItems = document.querySelectorAll('digi-navigation-vertical-menu-item[af-active="true"]');
          if(menuItems) {
            menuItems.forEach((el) => el.setAttribute('af-active', 'false'));
          }
          if(target) {
            target.setAttribute('af-active', 'true');
          }
        }
        document.addEventListener('afOnClick', (e) => {
          if(e.target.matches('.digi-navigation-sidebar-button')) {
            e.stopImmediatePropagation();
            afActive = !afActive;
            document.querySelector('digi-navigation-sidebar').setAttribute('af-active', afActive);
          }
          if(e.target.matches('digi-navigation-vertical-menu-item:not([af-active-subnav])')) {
            e.detail.preventDefault();
            setActiveMenuItem(e.target);
          }
        });
        document.addEventListener('afOnClose', () => closeSidebar());
        document.addEventListener('afOnEsc', () => closeSidebar());
        document.addEventListener('afOnBackdropClick', () => closeSidebar());
        // document.addEventListener('afOnToggle', (e) => console.log(e)});
      </script>
      <header>
        <digi-layout-container>
          <div class="header-inner">
            <digi-logo></digi-logo>
            <digi-navigation-sidebar-button class="test" af-text="Meny" af-aria-label="Öppnar/stänger menyn"></digi-navigation-sidebar-button>
          </div>
        </digi-layout-container>
      </header>
      <div class="main">
        <digi-typography>
          <digi-layout-block>
            <digi-navigation-sidebar
              af-active="true"
              af-sticky-header="true"
              af-backdrop="true"
              af-position="end"
              af-variation="over"
              af-close-button-text="Stäng"
            >
              <digi-navigation-vertical-menu>
                <ul>
                  <li>
                    <digi-navigation-vertical-menu-item af-text="About" af-active-subnav="false"></digi-navigation-vertical-menu-item>
                    <ul>
                      <li>
                        <digi-navigation-vertical-menu-item af-text="About 1" af-href="/about/about-1"></digi-navigation-vertical-menu-item></digi-navigation-vertical-menu-item>
                      </li>
                      <li>
                        <digi-navigation-vertical-menu-item af-text="About 2" af-href="/about/about-2"></digi-navigation-vertical-menu-item></digi-navigation-vertical-menu-item>
                      </li>
                    </ul>
                  </li>
                  <li>
                    <digi-navigation-vertical-menu-item af-text="Pages" af-active-subnav="false"></digi-navigation-vertical-menu-item>
                    <ul>
                      <li>
                        <digi-navigation-vertical-menu-item af-text="Pages 1" af-href="/pages/pages-1"></digi-navigation-vertical-menu-item>
                      </li>
                      <li>
                        <digi-navigation-vertical-menu-item af-text="Pages 2" af-href="/pages/pages-2"></digi-navigation-vertical-menu-item>
                      </li>
                      <li>
                        <digi-navigation-vertical-menu-item af-text="Pages 3" af-href="/grafisk-profil/pages-3"></digi-navigation-vertical-menu-item>
                      </li>
                    </ul>
                  </li>
                  <li>
                    <digi-navigation-vertical-menu-item af-text="Contact" af-href="/contact"></digi-navigation-vertical-menu-item>
                  </li>
                </ul>
              </digi-navigation-vertical-menu>
            </digi-navigation-sidebar>
            <digi-typography-heading-jumbo af-text="The main heading"></digi-typography-heading-jumbo>
            <digi-typography-preamble>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam et ornare nisl. Phasellus ut ultrices justo, at lacinia dolor.</digi-typography-preamble>
            <h2>Heading for a section</h2>
            <p>Vestibulum eget fermentum nibh, quis auctor nisl. Morbi quam libero, aliquam eu vehicula vel, maximus vitae felis. Curabitur pellentesque arcu vel mi ultricies convallis. In eu consectetur purus.</p>
            <p>Quisque porttitor justo ac est finibus, eget imperdiet sapien aliquet. Phasellus tincidunt mi in nulla porttitor, vel efficitur ex luctus. Morbi nisl enim, bibendum vel aliquam in, efficitur non dui.</p>
            <p>Ut lobortis odio in diam euismod pretium. Praesent viverra lacinia nibh ut eleifend. Suspendisse potenti. Vivamus facilisis ut dolor et facilisis. Suspendisse nec augue eu mauris tempus egestas.</p>
          </digi-layout-block>
        <digi-typography>
      </div>
    `}
  </Story>
</Canvas>
